#include "IRSender.hpp"

#include <string>

#include "driver/gpio.h"
#include "driver/ledc.h"

// project specific
#include "SpiderLib/NumberTypes.hpp"


IRSender::IRSender(u8 TXpin, u8 CLKpin, u8 UARTchannel, u8 LEDCchannel) {

  ledc_timer_config_t ledc_timer;
  ledc_timer.duty_resolution = LEDC_TIMER_1_BIT;
  ledc_timer.freq_hz = 38000;
  ledc_timer.speed_mode = LEDC_HIGH_SPEED_MODE;
  ledc_timer.timer_num = LEDC_TIMER_0;

  // Required for newer esp-idf:
  //ledc_timer.clk_cfg = LEDC_AUTO_CLK,             // Auto select the source clock

  ledc_timer_config(&ledc_timer);
  ledc_fade_func_install(0);


  gpio_config_t conf;

  conf.intr_type = GPIO_INTR_DISABLE;
  conf.mode = GPIO_MODE_OUTPUT;
  conf.pin_bit_mask = 1ULL << CLKpin;
  conf.pull_up_en = GPIO_PULLUP_DISABLE;
  conf.pull_down_en = GPIO_PULLDOWN_DISABLE;

  gpio_config(&conf);


  ledc_channel_config_t ledc_channel;
  ledc_channel.channel    = (ledc_channel_t)LEDCchannel;
  ledc_channel.duty       = 1;
  ledc_channel.gpio_num   = (gpio_num_t)CLKpin;
  ledc_channel.speed_mode = LEDC_HIGH_SPEED_MODE;
  ledc_channel.hpoint     = 0;
  ledc_channel.timer_sel  = LEDC_TIMER_0;

  ledc_channel_config(&ledc_channel);



  // TODO: configure UART!!!

}

void IRSender::send(u8 byte) {

}

void IRSender::send(std::string &data) {
 
}

void IRSender::send(u8 *buffer, size_t length) {

}


